#include <stdio.h>
#include <math.h>
#include "km.h"

void outspc(char *fft, float *spc, long n)
{
  long j,n2;
  float f;
  FILE *fp;
  
  n2=n/2;
  fp=fopen(fft,"w");
  for(j=n2+1;j<=n;j++){
    f=(j-n-1)/(1.0*n);
    fprintf(fp,"%g %g\n",f,spc[j]);
  }
  for(j=1;j<=n2+1;j++){
    f=(j-1)/(1.0*n);
    fprintf(fp,"%g %g\n",f,spc[j]);
  }
  fclose(fp);
}

void readhk(char *file, int ps, int tel, long n0, long n,
	    double *hh1, double *kk1)
{
  int i;
  long j;
  double buf,buf1,buf2;
  FILE *fp;
  
  fp=fopen(file,"r");
  for(j=1;j<n0;j++){
    fscanf(fp,"%lg",&buf);
    for(i=1;i<=ps;i++)
      fscanf(fp,"%lg %lg",&buf1,&buf2);
  }
  for(j=1;j<=n;j++){
    fscanf(fp,"%lg",&buf);
    for(i=1;i<=tel;i++)
      fscanf(fp,"%lg %lg",&buf1,&buf2);
    hh1[j]=buf1;
    kk1[j]=buf2;
    for(i=tel+1;i<=ps;i++)
      fscanf(fp,"%lg %lg",&buf1,&buf2);
  }
  fclose(fp);
}

void readhk2(FILE *fp, int ps, int tel, double *hh1, double *kk1)
{
  int i;
  double buf,buf1,buf2;
  
  fscanf(fp,"%lg",&buf);
  for(i=1;i<=tel;i++)
    fscanf(fp,"%lg %lg",&buf1,&buf2);
  *hh1=buf1;
  *kk1=buf2;
  for(i=tel+1;i<=ps;i++)
    fscanf(fp,"%lg %lg",&buf1,&buf2);
}

void readcoef(char *coef, int *k, double *alfa, double *beta)
{
  int j;
  double div,*beta2;
  FILE *fp;
  
  fp=fopen(coef,"r");
  fscanf(fp,"%d %lg",k,&div);
  beta2=dvector(0,*k);
  for(j=0;j<=*k;j++)
    fscanf(fp,"%lg %lg",&alfa[j],&beta2[j]);
  fclose(fp);
  for(j=0;j<=*k;j++)
    beta[j]=beta2[j]/div;
}

void readini(char *init,int *p,double *m,double *t,
	     double *x,double *y,double *z,double *vx,double *vy,double *vz)
{
  int i;
  FILE *fp;
  
  fp=fopen(init,"r");
  fscanf(fp,"%d",p);
  for(i=1;i<=*p;i++)
    fscanf(fp,"%lg",&m[i]);
  fscanf(fp,"%lg",t);
  for(i=1;i<=*p;i++)
    fscanf(fp,"%lg %lg %lg %lg %lg %lg",
	   &x[i],&y[i],&z[i],&vx[i],&vy[i],&vz[i]);
  fclose(fp);
}

void readout(FILE *fp,int p,double *t,
	     double *x,double *y,double *z,double *vx,double *vy,double *vz)
{
  int i;
  
  fscanf(fp,"%lg",t);
  for(i=1;i<=p;i++)
    fscanf(fp,"%lg %lg %lg %lg %lg %lg",
	   &x[i],&y[i],&z[i],&vx[i],&vy[i],&vz[i]);
}

void readbin(FILE *fp,int p,double *t,
             double *x,double *y,double *z,double *vx,double *vy,double *vz)
{
  int i;

  fread(t,8,1,fp);
  for(i=1;i<=p;i++){
    fread(&x[i],8,1,fp);
    fread(&y[i],8,1,fp);
    fread(&z[i],8,1,fp);
    fread(&vx[i],8,1,fp);
    fread(&vy[i],8,1,fp);
    fread(&vz[i],8,1,fp);
  }  
}

void readhkbin(char *file, int ps, int tel, long n0, long n,
	    double *hh1, double *kk1)
{
  int i;
  long j;
  double buf,buf1,buf2;
  FILE *fp;
  
  fp=fopen(file,"rb");
  for(j=1;j<n0;j++){
    fread(&buf,8,1,fp);
    for(i=1;i<=ps;i++){
      fread(&buf1,8,1,fp);
      fread(&buf2,8,1,fp);
    }
  }
  for(j=1;j<=n;j++){
    fread(&buf,8,1,fp);
    for(i=1;i<=tel;i++){
      fread(&buf1,8,1,fp);
      fread(&buf2,8,1,fp);
    }
    hh1[j]=buf1;
    kk1[j]=buf2;
    for(i=tel+1;i<=ps;i++){
      fread(&buf1,8,1,fp);
      fread(&buf2,8,1,fp);
    }
  }
  fclose(fp);
}


void saveini(char *init, int p, double *m, double t,
	     double *x,double *y,double *z,double *vx,double *vy,double *vz)
{
  int i;
  FILE *fp;
  
  fp=fopen(init,"w");
  fprintf(fp,"%d\n",p);
  for(i=1;i<=p;i++)
    fprintf(fp,"%.15lg ",m[i]);
  fprintf(fp,"\n%lg\n",t);
  for(i=1;i<=p;i++)
    fprintf(fp,"%.15lg %.15lg %.15lg %.15lg %.15lg %.15lg\n",
	    x[i],y[i],z[i],vx[i],vy[i],vz[i]);
  fclose(fp);
}

void readp(char *init, int *p)
{
  int i;
  FILE *fp;
  
  fp=fopen(init,"r");
  fscanf(fp,"%d",p);
  fclose(fp);
}

void readm(char *init, double *m)
{
  int i,p;
  FILE *fp;
  
  fp=fopen(init,"r");
  fscanf(fp,"%d",&p);
  for(i=1;i<=p;i++)
    fscanf(fp,"%lg",&m[i]);
  fclose(fp);
}

void readt(char *init, double *t)
{
  int i,p;
  double m;
  FILE *fp;
  
  fp=fopen(init,"r");
  fscanf(fp,"%d",&p);
  for(i=1;i<=p;i++)
    fscanf(fp,"%lg",&m);
  fscanf(fp,"%lg",t);
  fclose(fp);
}

void addx(char *out, double t, int n, double *x, double *y,double *z)
{
  int i;
  FILE *fp;
  
  fp=fopen(out,"a");
  fprintf(fp,"%.15lg\n",t);
  for(i=1;i<=n;i++)
    fprintf(fp,"%.15lg %.15lg %.15lg\n",x[i],y[i],z[i]);
  fprintf(fp,"\n");
  fclose(fp);
}

void addxv(char *out, double t, int n, double *x, double *y,double *z,
	   double *vx, double *vy, double *vz)
{
  int i;
  FILE *fp;
  
  fp=fopen(out,"a");
  fprintf(fp,"%.15lg\n",t);
  for(i=1;i<=n;i++)
    fprintf(fp,"%.15lg %.15lg %.15lg %.15lg %.15lg %.15lg\n",
	    x[i],y[i],z[i],vx[i],vy[i],vz[i]);
  fprintf(fp,"\n");
  fclose(fp);
}

void addbin(char *out, double t, int n, double *x, double *y, double *z,
           double *vx, double *vy, double *vz)
{
  int i;
  FILE *fp;

  fp=fopen(out,"ab");
  fwrite(&t,8,1,fp);
  for(i=1;i<=n;i++){
    fwrite(&x[i],8,1,fp);
    fwrite(&y[i],8,1,fp);
    fwrite(&z[i],8,1,fp);
    fwrite(&vx[i],8,1,fp);
    fwrite(&vy[i],8,1,fp);
    fwrite(&vz[i],8,1,fp);
  }
  fclose(fp);
}

void addhkbin(char *out, double t, int n, double *h, double *k)
{
  int i;
  FILE *fp;

  fp=fopen(out,"ab");
  fwrite(&t,8,1,fp);
  for(i=1;i<=n;i++){
    fwrite(&h[i],8,1,fp);
    fwrite(&k[i],8,1,fp);
  }
  fclose(fp);
}

void addhk(char *out, double t, int n, double *h, double *k)
{
  int i;
  FILE *fp;
  
  fp=fopen(out,"a");
  fprintf(fp,"%.15lg\n",t);
  for(i=1;i<=n;i++)
    fprintf(fp,"%.15lg %.15lg\n",h[i],k[i]);
  fprintf(fp,"\n");
  fclose(fp);
}

void dumpx(char *out, double t, int n, int mo, double **x, double **y,
	   double **z, double step)
{
  int i,j;
  double t2;
  FILE *fp;
  
  fp=fopen(out,"w");
  for(j=mo;j>=0;j--) {
    t2=t-(mo-j)*step;
    fprintf(fp,"%.15lg\n",t2);
    for(i=1;i<=n;i++)
      fprintf(fp,"%.15lg %.15lg %.15lg\n",x[j][i],y[j][i],z[j][i]);
    fprintf(fp,"\n");
  }
  fclose(fp);
}

void dumpxv(char *out,double t,int n,int mo,double **x,double **y,
	    double **z,double **ax,double **ay,double **az,double step)
{
  int i,j;
  double t2;
  FILE *fp;
  
  fp=fopen(out,"w");
  for(j=mo;j>=0;j--) {
    t2=t-(mo-j)*step;
    fprintf(fp,"%.15lg\n",t2);
    for(i=1;i<=n;i++)
      fprintf(fp,"%.15lg %.15lg %.15lg %.15lg %.15lg %.15lg\n",
	      x[j][i],y[j][i],z[j][i],ax[j][i],ay[j][i],az[j][i]);
    fprintf(fp,"\n");
  }
  fclose(fp);
}









