/* multistep integrator with restart ================================ */

#include <math.h>
#include <stdio.h>
#include "km.h"

int main(void)
{
  char pri[ML],sec[ML],coef[ML],param[ML];
  char init[ML],start[ML],out[ML],dump[ML];
  char inits[ML],starts[ML],startas[ML],outsec[ML],dumps[ML];
  char coefx[ML],coefv[ML],buf[ML];
  char outd[ML],outsd[ML];
  int acceleration,info;
  FILE *fp,*fp1,*fp2;
  double step;
  long int steps,outs;
  int order,orderv,mo;
  double alfa[MK],beta[MK],alfav[MK],betav[MK];
  int p,ps;
  double t,*m,**x,**y,**z,*vx,*vy,*vz,**ax,**ay,**az;
  double *ms,**xs,**ys,**zs,*vxs,*vys,*vzs,**axs,**ays,**azs;
  int i,j;
  long int k,l;
  double dec,douts;
  int ch;
  double ph[10],gm,draga,dragc;
/* =============================================================== */
  if(ctii("which_acceler",&acceleration)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctii("vystup_info",&info)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(ctid("GM_",&gm)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctid("drag_alpha",&draga)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctid("drag_c",&dragc)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  ph[1]=gm; ph[2]=draga; ph[3]=dragc;
	
  if(ctid("step_integ",&step)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctil("sample_integ",&steps)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctil("outs_integ",&outs)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctid("dumps_integ",&douts)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(cti("coef_integ",coefx)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("coef_velo",coefv)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(cti("pri_out_init",init)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("pri_out_start",start)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("pri_out_integ",out)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("pri_dump_integ",dump)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(cti("sec_out_init",inits)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_out_start",starts)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_out_integ",outsec)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_dump_integ",dumps)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("accsec_start",startas)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(cti("pri_out_bak",outd)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_out_bak",outsd)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }    
/* ============================================================ */
  readcoef(coefx,&order,alfa,beta);
  readcoef(coefv,&orderv,alfav,betav);
  mo=IMAX(order,orderv);
  readp(init,&p); m=dvector(0,p); readm(init,m);
  x=dmatrix(0,mo,0,p); y=dmatrix(0,mo,0,p); z=dmatrix(0,mo,0,p);
  vx=dvector(0,p); vy=dvector(0,p); vz=dvector(0,p);
  ax=dmatrix(0,mo,0,p); ay=dmatrix(0,mo,0,p); az=dmatrix(0,mo,0,p);
  fp=fopen(start,"r");
  for(j=0;j<=mo;j++){
    fscanf(fp,"%lg",&t);
    for(i=1;i<=p;i++)
      fscanf(fp,"%lg %lg %lg %lg %lg %lg",
	     &x[j][i],&y[j][i],&z[j][i],&ax[j][i],&ay[j][i],&az[j][i]);
  }
  fclose(fp);
/* ============================================================= */
  readp(inits,&ps); ms=dvector(0,ps); readm(inits,ms);
  xs=dmatrix(0,mo,0,ps); ys=dmatrix(0,mo,0,ps); zs=dmatrix(0,mo,0,ps);
  vxs=dvector(0,ps); vys=dvector(0,ps); vzs=dvector(0,ps);
  axs=dmatrix(0,mo,0,ps); ays=dmatrix(0,mo,0,ps); azs=dmatrix(0,mo,0,ps);
  fp=fopen(starts,"r");
  for(j=0;j<=mo;j++){
    fscanf(fp,"%lg",&t);
    for(i=1;i<=ps;i++)
      fscanf(fp,"%lg %lg %lg %lg %lg %lg",&xs[j][i],
	     &ys[j][i],&zs[j][i],&axs[j][i],&ays[j][i],&azs[j][i]);
  }
  fclose(fp);
/* ============================================================== */
  remove(outd); remove(outsd);
  if(outs < douts){
    fprintf(stderr,"error: too many dumps_integ for given outs_integ\n"); 
    return(KO);
  }
  dec=floor(outs/douts);
  reverse(p,mo,x,y,z,ax,ay,az);
  reverse(ps,mo,xs,ys,zs,axs,ays,azs);
  t=t-mo*step;
  step=-step;
/* the first output =========================================== */
  vel(p,x,y,z,vx,vy,vz,ax,ay,az,mo-orderv,orderv,alfav,betav,step);
  vel(ps,xs,ys,zs,vxs,vys,vzs,axs,ays,azs,mo-orderv,orderv,alfav,betav,
      step);
  addxv(outd,t,p,x[mo],y[mo],z[mo],vx,vy,vz);
  addxv(outsd,t,ps,xs[mo],ys[mo],zs[mo],vxs,vys,vzs);
/* nucleus ==================================================== */
  for(l=1;l<=outs;l++){
    if(info) printf("%ld ",l);
    for(k=1;k<=steps;k++){
      shift(p,mo,x,y,z,ax,ay,az);
      shift(ps,mo,xs,ys,zs,axs,ays,azs);
      gomsi(p,x,y,z,ax,ay,az,mo-order,order,alfa,beta,step);
      gomsi(ps,xs,ys,zs,axs,ays,azs,mo-order,order,alfa,beta,step);
      switch(acceleration) {
      case 1: 
	accprim(p,m,x[mo],y[mo],z[mo],vx,vy,vz,ax[mo],ay[mo],az[mo],ph);
	accsec(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
	       vxs,vys,vzs,axs[mo],ays[mo],azs[mo],ph);
	break;
	
      case 2: 
	vel(p,x,y,z,vx,vy,vz,ax,ay,az,mo-orderv,orderv,alfav,betav,step);
	vel(ps,xs,ys,zs,vxs,vys,vzs,axs,ays,azs,mo-orderv,orderv,
	    alfav,betav,step);
	accprimrel(p,m,x[mo],y[mo],z[mo],vx,vy,vz,ax[mo],ay[mo],az[mo],ph);
	accsecrel(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
		  vxs,vys,vzs,axs[mo],ays[mo],azs[mo],ph);
	break;
      case 3: 
	vel(ps,xs,ys,zs,vxs,vys,vzs,axs,ays,azs,
	    mo-orderv,orderv,alfav,betav,step);
	accprim(p,m,x[mo],y[mo],z[mo],vx,vy,vz,ax[mo],ay[mo],az[mo],ph);
	accsec2(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
		vxs,vys,vzs,axs[mo],ays[mo],azs[mo],ph);
	break;
      }
/* end of switch ============================================== */
      t=t+step;
    }
    if(fmod(l,dec) == 0.0) {
      dumpxv(dump,t,p,mo,x,y,z,ax,ay,az,step);
      dumpxv(dumps,t,ps,mo,xs,ys,zs,axs,ays,azs,step);
      fp1=fopen(outd,"r");
      fp2=fopen(out,"a");
      while((ch=fgetc(fp1)) != EOF) fputc(ch,fp2);
      fclose(fp1);
      fclose(fp2);
      fp1=fopen(outsd,"r");
      fp2=fopen(outsec,"a");
      while((ch=fgetc(fp1)) != EOF) fputc(ch,fp2);
      fclose(fp1);
      fclose(fp2);
      remove(outd); remove(outsd);
    }
    vel(p,x,y,z,vx,vy,vz,ax,ay,az,mo-orderv,orderv,alfav,betav,step);
    vel(ps,xs,ys,zs,vxs,vys,vzs,axs,ays,azs,mo-orderv,orderv,alfav,
	betav,step);
    addxv(outd,t,p,x[mo],y[mo],z[mo],vx,vy,vz);
    addxv(outsd,t,ps,xs[mo],ys[mo],zs[mo],vxs,vys,vzs);
  }
  if(info) printf("\n");
  return(OK);
}




