/* digital filtering of osculating elements */

#include <math.h>
#include <stdio.h>
#include "km.h" 

int main(void)
{
  char init[ML],inits[ML],out[ML],outsec[ML],out2[ML],outs2[ML],dfile[ML];
  int p,i;
  double t;
  double *m,*x,*y,*z,*vx,*vy,*vz;
  double ***a,***e,***ii,***o,***oo,***nt;
  double *obak,*oobak,*ntbak;
  double **af,**ef,**iif,**of,**oof,**ntf;
  int ps;
  double *ms,*xs,*ys,*zs,*vxs,*vys,*vzs;
  double ***as,***es,***iis,***os,***oos,***nts;
  double *osbak,*oosbak,*ntsbak;
  double **asf,**esf,**iisf,**osf,**oosf,**ntsf;
  double t2;
  double *a2,*e2,*ii2,*o2,*oo2,*nt2;
  double *as2,*es2,*iis2,*os2,*oos2,*nts2;
  FILE *fp;
  long l,steps,outs,nofouts;
  double step;
  int decfactor,*dec,n,noff;
  double *d;
  int m1,m2,j1,j2,j3,j;
  long pom,decim,ndec;
  double ph[10],gm;
/* =============================================================== */
  if(ctid("GM_for_out",&gm)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  ph[1]=gm;

  if(ctii("number_of_fil",&noff)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctii("dec_factor",&decfactor)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(ctid("step_integ",&step)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctil("sample_integ",&steps)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctil("outs_integ",&outs)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(cti("pri_out_init",init)==KO){ 
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_out_init",inits)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
 
  if(cti("pri_out_integ",out)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_out_integ",outsec)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("pri_out2_integ",out2)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_out2_integ",outs2)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }   
 
  if(cti("used_filter",dfile)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

/* ================================================= */
  fp=fopen(dfile,"r");
  fscanf(fp,"%d",&m1);
  d=dvector(-m1,m1);
  for(j=-m1;j<=m1;j++)
    fscanf(fp,"%lg",&d[j]);
  fclose(fp);
  m2=2*m1;

  dec=ivector(1,noff);
  for(i=1;i<=noff;i++) dec[i]=decfactor;
/* ==================================================== */    
  readp(init,&p); m=dvector(0,p); readm(init,m); readt(init,&t);
  x=dvector(0,p); y=dvector(0,p); z=dvector(0,p);
  vx=dvector(0,p); vy=dvector(0,p); vz=dvector(0,p);
  a=d3tensor(0,noff,0,m2,0,p); e=d3tensor(0,noff,0,m2,0,p);
  ii=d3tensor(0,noff,0,m2,0,p); o=d3tensor(0,noff,0,m2,0,p);
  oo=d3tensor(0,noff,0,m2,0,p); nt=d3tensor(0,noff,0,m2,0,p);
  af=dmatrix(0,noff,0,p); ef=dmatrix(0,noff,0,p); iif=dmatrix(0,noff,0,p);
  of=dmatrix(0,noff,0,p); oof=dmatrix(0,noff,0,p); ntf=dmatrix(0,noff,0,p);
  for(j1=0;j1<=noff;j1++)
    for(j2=0;j2<=m2;j2++)
      for(j3=0;j3<=p;j3++){
	a[j1][j2][j3]=e[j1][j2][j3]=ii[j1][j2][j3]=0;
	o[j1][j2][j3]=oo[j1][j2][j3]=nt[j1][j2][j3]=0;
      }
  /* readini(init,&p,m,&t,a[0][m2],e[0][m2],ii[0][m2],o[0][m2],oo[0][m2],nt[0][m2]); */
  
  readp(inits,&ps); ms=dvector(0,ps); readm(inits,ms); readt(inits,&t);
  xs=dvector(0,ps); ys=dvector(0,ps); zs=dvector(0,ps);
  vxs=dvector(0,ps); vys=dvector(0,ps); vzs=dvector(0,ps);
  as=d3tensor(0,noff,0,m2,0,ps); es=d3tensor(0,noff,0,m2,0,ps);
  iis=d3tensor(0,noff,0,m2,0,ps); os=d3tensor(0,noff,0,m2,0,ps);
  oos=d3tensor(0,noff,0,m2,0,ps); nts=d3tensor(0,noff,0,m2,0,ps);
  asf=dmatrix(0,noff,0,ps); esf=dmatrix(0,noff,0,ps); iisf=dmatrix(0,noff,0,ps);
  osf=dmatrix(0,noff,0,ps); oosf=dmatrix(0,noff,0,ps); ntsf=dmatrix(0,noff,0,ps);
  for(j1=0;j1<=noff;j1++)
    for(j2=0;j2<=m2;j2++)
      for(j3=0;j3<=ps;j3++){
	as[j1][j2][j3]=es[j1][j2][j3]=iis[j1][j2][j3]=0;
	os[j1][j2][j3]=oos[j1][j2][j3]=nts[j1][j2][j3]=0;
      }
  /* readini(inits,&ps,ms,&t,as[0][m2],es[0][m2],iis[0][m2],os[0][m2],oos[0][m2],nts[0][m2]); */ 
  a2=dvector(0,p); e2=dvector(0,p); ii2=dvector(0,p);
  o2=dvector(0,p); oo2=dvector(0,p); nt2=dvector(0,p);
  as2=dvector(0,ps); es2=dvector(0,ps); iis2=dvector(0,ps);
  os2=dvector(0,ps); oos2=dvector(0,ps); nts2=dvector(0,ps);

  obak=dvector(0,p); oobak=dvector(0,p); ntbak=dvector(0,p);
  osbak=dvector(0,ps); oosbak=dvector(0,ps); ntsbak=dvector(0,ps);
/* ============================================================= */
  ndec=1;
  for(n=1;n<=noff;n++){
    ndec=ndec*dec[n];
  }

  fp=fopen(out,"r");
  for(l=0;l<outs;l++) {
    for(i=1;i<=1;i++) readout(fp,p,&t,x,y,z,vx,vy,vz);
    shift3(p,m2,a[0],e[0]);
    shift3(p,m2,ii[0],o[0]);
    shift3(p,m2,oo[0],nt[0]);
    katos(p,m,t,a[0][m2],e[0][m2],ii[0][m2],o[0][m2],oo[0][m2],nt[0][m2],
	  x,y,z,vx,vy,vz,ph);
    
    if(fmod(l-m1*ndec,ndec) == 0. && l>=m1*ndec){
      for(i=1;i<=p;i++){
	obak[i]=o[0][m2][i];
	oobak[i]=oo[0][m2][i];
	ntbak[i]=nt[0][m2][i];
      }
    }

    decim=1;
    pom=0; 
    for(n=1;n<=noff;n++){
      pom=pom+decim;
      decim=decim*dec[n];
      if(fmod(l-m1*(pom+decim),decim) == 0. && l>=m1*(pom+decim)){
	filter(p,m1,d,a[n-1],e[n-1],af[n],ef[n]);
	filter(p,m1,d,ii[n-1],o[n-1],iif[n],of[n]);
	filter(p,m1,d,oo[n-1],nt[n-1],oof[n],ntf[n]);
	shift3(p,m2,a[n],e[n]);
	shift3(p,m2,ii[n],o[n]);
	shift3(p,m2,oo[n],nt[n]);
	for(i=1;i<=p;i++){
	  a[n][m2][i]=af[n][i];
	  e[n][m2][i]=ef[n][i];
	  ii[n][m2][i]=iif[n][i];
	  o[n][m2][i]=of[n][i];
	  oo[n][m2][i]=oof[n][i];
	  nt[n][m2][i]=ntf[n][i];
	}
	if(n==noff){
	  t2=t+step*steps*m1*pom;
	  for(i=1;i<=p;i++){
	    a2[i]=af[n][i];
	    e2[i]=ef[n][i];
	    ii2[i]=iif[n][i];
	    o2[i]=of[n][i];
	    oo2[i]=oof[n][i];
	    nt2[i]=ntf[n][i];
	  }
	  addxv(out2,t2,p,a2,e2,ii2,obak,oobak,ntbak); 
	}
      }
    }
  }
  fclose(fp);
/* ================================================================== */
  fp=fopen(outsec,"r");
  for(l=0;l<outs;l++) {
    for(i=1;i<=1;i++) readout(fp,ps,&t,xs,ys,zs,vxs,vys,vzs);
    shift3(ps,m2,as[0],es[0]);
    shift3(ps,m2,iis[0],os[0]);
    shift3(ps,m2,oos[0],nts[0]);
    katos(ps,ms,t,as[0][m2],es[0][m2],iis[0][m2],os[0][m2],oos[0][m2],nts[0][m2],
	  xs,ys,zs,vxs,vys,vzs,ph);

    if(fmod(l-m1*ndec,ndec) == 0. && l>=m1*ndec){
      for(i=1;i<=ps;i++){
	osbak[i]=os[0][m2][i];
	oosbak[i]=oos[0][m2][i];
	ntsbak[i]=nts[0][m2][i];
      }
    }

    decim=1;
    pom=0;
    for(n=1;n<=noff;n++){
      pom=pom+decim;
      decim=decim*dec[n];
      if(fmod(l-m1*(pom+decim),decim) == 0. && l>=m1*(pom+decim)){
	filter(ps,m1,d,as[n-1],es[n-1],asf[n],esf[n]);
	filter(ps,m1,d,iis[n-1],os[n-1],iisf[n],osf[n]);
	filter(ps,m1,d,oos[n-1],nts[n-1],oosf[n],ntsf[n]);
	shift3(ps,m2,as[n],es[n]);
	shift3(ps,m2,iis[n],os[n]);
	shift3(ps,m2,oos[n],nts[n]);
	for(i=1;i<=ps;i++){
	  as[n][m2][i]=asf[n][i];
	  es[n][m2][i]=esf[n][i];
	  iis[n][m2][i]=iisf[n][i];
	  os[n][m2][i]=osf[n][i];
	  oos[n][m2][i]=oosf[n][i];
	  nts[n][m2][i]=ntsf[n][i];
	}
	if(n==noff){
	  t2=t+step*steps*m1*pom;
	  for(i=1;i<=ps;i++){
	    as2[i]=asf[n][i];
	    es2[i]=esf[n][i];
	    iis2[i]=iisf[n][i];
	    os2[i]=osf[n][i];
	    oos2[i]=oosf[n][i];
	    nts2[i]=ntsf[n][i];
	  }
	  addxv(outs2,t2,ps,as2,es2,iis2,osbak,oosbak,ntsbak); 
	}
      }
    }
  }
  fclose(fp);
/* =============================================================== */
  return(OK);
}













