/* starting procedure uses R-K 4, differential step size */

#include <math.h>
#include <stdio.h>
#include "km.h"

int main(void)
{
  char pri[ML],sec[ML],coef[ML],param[ML];
  char init[ML],start[ML],out[ML],dump[ML];
  char inits[ML],starts[ML],startas[ML],outsec[ML],dumps[ML];
  char coefx[ML],coefv[ML],buf[ML];
  int acceleration,info;
  FILE *fp;
  double step;
  long int steps,outs;
  int order=1,mo=1,red;
  double a[5]={0.0,1.0/6.0,1.0/3.0,1.0/3.0,1.0/6.0};
  double q[5]={0.0,0.0,0.5,0.5,1.0};
  int p,ps;
  double t,*m,**x,**y,**z,**vx,**vy,**vz,**ax,**ay,**az;
  double *ms,**xs,**ys,**zs,**vxs,**vys,**vzs,**axs,**ays,**azs;
  int i,j;
  long int k,l;
  double ph[10],gm,draga,dragc;
/* =============================================================== */
  if(ctii("which_acceler",&acceleration)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctii("vystup_info",&info)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(ctid("GM_",&gm)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctid("drag_alpha",&draga)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctid("drag_c",&dragc)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  ph[1]=gm; ph[2]=draga; ph[3]=dragc;

  if(ctii("pri_step_reduct",&red)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctid("step_start",&step)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctil("sample_start",&steps)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(ctil("outs_start",&outs)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }

  if(cti("pri_out_init",init)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("pri_out_start",start)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_out_init",inits)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
  if(cti("sec_out_start",starts)==KO){
    fprintf(stderr,"error in config\n");
    return(KO);
  }
/* ============================================================= */
  readp(init,&p); m=dvector(0,p); readm(init,m);
  x=dmatrix(0,mo,0,p); y=dmatrix(0,mo,0,p); z=dmatrix(0,mo,0,p);
  vx=dmatrix(0,mo,0,p); vy=dmatrix(0,mo,0,p); vz=dmatrix(0,mo,0,p);
  ax=dmatrix(0,mo,0,p); ay=dmatrix(0,mo,0,p); az=dmatrix(0,mo,0,p);
  readini(init,&p,m,&t,x[mo],y[mo],z[mo],vx[mo],vy[mo],vz[mo]);
/* ============================================================= */
  readp(inits,&ps); ms=dvector(0,ps); readm(inits,ms);
  xs=dmatrix(0,mo,0,ps); ys=dmatrix(0,mo,0,ps); zs=dmatrix(0,mo,0,ps);
  vxs=dmatrix(0,mo,0,ps); vys=dmatrix(0,mo,0,ps); vzs=dmatrix(0,mo,0,ps);
  axs=dmatrix(0,mo,0,ps); ays=dmatrix(0,mo,0,ps); azs=dmatrix(0,mo,0,ps);
  readini(inits,&ps,ms,&t,xs[mo],ys[mo],zs[mo],vxs[mo],vys[mo],vzs[mo]);
/* ============================================================== */
  switch(acceleration) {
  case 1: 
    accprim(p,m,x[mo],y[mo],z[mo],vx[mo],vy[mo],vz[mo],
	    ax[mo],ay[mo],az[mo],ph);
    accsec(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
	   vxs[mo],vys[mo],vzs[mo],axs[mo],ays[mo],azs[mo],ph);
    break;
  case 2: 
    accprimrel(p,m,x[mo],y[mo],z[mo],vx[mo],vy[mo],vz[mo],
	       ax[mo],ay[mo],az[mo],ph);
    accsecrel(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
	      vxs[mo],vys[mo],vzs[mo],axs[mo],ays[mo],azs[mo],ph);
    break;
  case 3: 
    accprim(p,m,x[mo],y[mo],z[mo],vx[mo],vy[mo],vz[mo],
	    ax[mo],ay[mo],az[mo],ph);
    accsec2(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
	    vxs[mo],vys[mo],vzs[mo],axs[mo],ays[mo],azs[mo],ph);
    break;
  }
/* end of switch ============================================== */
  addxv(start,t,p,x[mo],y[mo],z[mo],ax[mo],ay[mo],az[mo]);
  addxv(starts,t,ps,xs[mo],ys[mo],zs[mo],axs[mo],ays[mo],azs[mo]);  
  outs=outs*red;
  steps=steps/red;
  for(l=1;l<=outs;l++){
    if(info) printf("%ld ",l);
    for(k=1;k<=steps;k++){
      shift(p,mo,x,y,z,ax,ay,az);
      shift(ps,mo,xs,ys,zs,axs,ays,azs);
      shift2(p,mo,vx,vy,vz);
      shift2(ps,mo,vxs,vys,vzs);
      switch(acceleration) {
      case 1:	
	gork(p,m,x,y,z,vx,vy,vz,ps,xs,ys,zs,vxs,vys,vzs,
	     mo,mo-order,a,q,step,ph,accprim,accsec); break;
      case 2: 
	gork(p,m,x,y,z,vx,vy,vz,ps,xs,ys,zs,vxs,vys,vzs,
	     mo,mo-order,a,q,step,ph,accprimrel,accsecrel); break;
      case 3: 
	gork(p,m,x,y,z,vx,vy,vz,ps,xs,ys,zs,vxs,vys,vzs,
	     mo,mo-order,a,q,step,ph,accprim,accsec2); break;
      }
      t=t+step;
    }
    switch(acceleration) {
    case 1: 
      accprim(p,m,x[mo],y[mo],z[mo],vx[mo],vy[mo],vz[mo],
	      ax[mo],ay[mo],az[mo],ph);
      accsec(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
	     vxs[mo],vys[mo],vzs[mo],axs[mo],ays[mo],azs[mo],ph);
      break;
    case 2: 
      accprimrel(p,m,x[mo],y[mo],z[mo],vx[mo],vy[mo],vz[mo],
		 ax[mo],ay[mo],az[mo],ph);
      accsecrel(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
		vxs[mo],vys[mo],vzs[mo],axs[mo],ays[mo],azs[mo],ph);
      break;
    case 3: 
      accprim(p,m,x[mo],y[mo],z[mo],vx[mo],vy[mo],vz[mo],
	      ax[mo],ay[mo],az[mo],ph);
      accsec2(p,m,x[mo],y[mo],z[mo],ps,xs[mo],ys[mo],zs[mo],
	      vxs[mo],vys[mo],vzs[mo],axs[mo],ays[mo],azs[mo],ph);
      break;
    }
/* end of switch ============================================== */
    addxv(start,t,p,x[mo],y[mo],z[mo],ax[mo],ay[mo],az[mo]);
    if(fmod(l,red)==0)
       addxv(starts,t,ps,xs[mo],ys[mo],zs[mo],axs[mo],ays[mo],azs[mo]);
  }
  if(info) printf("\n");
  return(OK);
}









